package com.blogspot.lifeinide.mule.integration.spring3mule2;

import org.mule.config.spring.MuleBeanDefinitionDocumentReader;
import org.mule.config.spring.MuleHierarchicalBeanDefinitionParserDelegate;
import org.springframework.beans.factory.xml.BeanDefinitionParserDelegate;
import org.springframework.beans.factory.xml.XmlReaderContext;
import org.w3c.dom.Element;

/**
 * Spring 3 compatible {@link MuleBeanDefinitionDocumentReader}.
 * 
 * @author l0co@wp.pl
 */
public class Spring3MuleBeanDefinitionDocumentReader extends MuleBeanDefinitionDocumentReader {

	public Spring3MuleBeanDefinitionDocumentReader() {
		super();
	}

	@Override
	protected BeanDefinitionParserDelegate createHelper(XmlReaderContext readerContext, Element root,
			BeanDefinitionParserDelegate parentDelegate) {
		BeanDefinitionParserDelegate delegate = new MuleHierarchicalBeanDefinitionParserDelegate(readerContext, this);
		delegate.initDefaults(root, parentDelegate);
		return delegate;
	}

}
