package com.blogspot.lifeinide.mule.integration.spring3mule2;

import org.mule.api.MuleContext;
import org.mule.api.config.ConfigurationException;
import org.mule.api.registry.Registry;
import org.mule.config.ConfigResource;
import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;

/**
 * Create Spring3 compatible {@link Spring3MuleApplicationContext}
 * 
 * @author l0co@wp.pl
 */
public class Spring3XmlConfigurationBuilder extends org.mule.config.spring.SpringXmlConfigurationBuilder {

	public Spring3XmlConfigurationBuilder(ConfigResource[] configResources, ApplicationContext parentContext) {
		super(configResources, parentContext);
	}

	public Spring3XmlConfigurationBuilder(ConfigResource[] configResources) {
		super(configResources);
	}

	public Spring3XmlConfigurationBuilder(String configResources, ApplicationContext parentContext)
			throws ConfigurationException {
		super(configResources, parentContext);
	}

	public Spring3XmlConfigurationBuilder(String configResources) throws ConfigurationException {
		super(configResources);
	}

	public Spring3XmlConfigurationBuilder(String[] configResources, ApplicationContext parentContext)
			throws ConfigurationException {
		super(configResources, parentContext);
	}

	public Spring3XmlConfigurationBuilder(String[] configResources) throws ConfigurationException {
		super(configResources);
	}

	protected void createSpringParentRegistry(MuleContext muleContext, Registry registry, ConfigResource[] all) {
		try {
			if (parentContext != null) {
				new Spring3MuleApplicationContext(muleContext, registry, all, parentContext);
			} else {
				new Spring3MuleApplicationContext(muleContext, registry, all);
			}
		} catch (BeansException e) {
			// If creation of MuleApplicationContext fails, remove
			// TransientRegistry->SpringRegistry parent relationship
			registry.setParent(null);
			throw e;
		}
	}

}
